
// What variables to show

typedef enum {
    Variables_not_set         = 0,
	No_variables              = 1,
	Global_variables          = 2,
	Static_variables          = 3,
	Static_function_variables = 4,
	Function_parameters       = 5,
	All_variables             = 6	// Up to and including nested locals
} variablesE;

class Cvariable : public Cclassmember {
private:
	Cvariable(const char *nameP);

public:
	static Cvariable 	*g_hash[HASHSIZE];
	static unsigned int	g_hash_cnt;
	static Cvariable	*g_local_headP;

	static Cvariable	*g_addr_hash[HASHSIZE];
	static unsigned int g_addr_hash_cnt;

	Cvariable		*m_hashP;
	Cvariable		*m_local_nextP;

	static void		reset(void);
	static Cvariable **exists(const char *nameP, int flags, const Centity *sourceP, const Centity *functionP, const Centity *addressesP);
	static Cvariable *locate(char *nameP, int flags, Centity *sourceP, Centity *functionP);
	static void     resolve(int show_variables, int no_function_calls);

	const char		*get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;
	virtual void	print(void) const;

	virtual void	emit_instance(void) const;
	virtual	void	emit_edges(void);
	virtual void	emit_attributes(void) const;
};

